MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0007691Community[OCCT] OCCT:Visualizationpublic2005-01-11 14:242012-03-29 17:26
Reporterabv 
Assigned Tobugmaster 
PrioritynormalSeveritytrivial 
StatusclosedResolutionfixed 
PlatformOSAllOS Version
Product Version 
Target Version[OCCT] 6.5.2Fixed in Version[OCCT] 6.5.2 
Summary0007691: Wrong hidden lines computed by HLRBRep_PolyAlgo and HLRBRep_PolyHLRToShape in OCC 5.1
DescriptionThis bug has been reported on OCC Forum by Paul Borowski, see thread 6628:
http://www.opencascade.org/org/forum/thread_6628 [^]

The fix is suggested by the same person, see below both description and fix:

--------------------

My application was written under OCC 50 and uses HLRBRep_PolyHLRToShape and
HLRBRep_PolyAlgo to compute hidden lines.
The code looks like this:
for (int i = 0; i < n; i++)
{
BRepMesh::Mesh(Shape(i), Deflection);
.....
m_HLR_Algo.Load (Shape(i));
}

m_HLR_Algo.Update();
m_aHLRToShape.Update(&m_HLR_Algo);
.....

// Create the result shape
TopoDS_Compound Shape;
BRep_Builder B;
B.MakeCompound(Shape);

TopoDS_Shape VCompound = m_aHLRToShape.VCompound(S);
if (!VCompound.IsNull())
{
B.Add(Shape, VCompound);
}

VCompound = m_aHLRToShape.OutLineVCompound(S);
if (!VCompound.IsNull())
{
B.Add(Shape, VCompound);
}
It works great under OCC50. Under OCC51, however, all shapes, which were added
to the HL algorithm seems to be transparent and all lines are returned as
visible! Any ideas, what can be a problem?

Regards,

Paul

----------

I spend a lot of time trying to fix the bug I have reported, but at last I had
success with it!

A solution for my problem:
Open ModellingAlgorithms project and take a look in the
OCC5.2\src\HLRBRep\HLRBRep_PolyAlgo.cxx file:

...
3654 // Tri1Flags &= ~FMskBack;
3655 Tri1Flags |= FMskBack;//OCC349
...

now comment out the line 3655 and restore the line 3654:

3654 Tri1Flags &= ~FMskBack;
3655 // Tri1Flags |= FMskBack;//OCC349

Recompile TKHLR.dll.

That's all.

-----------------

Note that according to information from VTN, this bug is likely a consequence of
fixing some other bug in HLR (probably OCC349?).
Additional information
and documentation updates
Changes:
There are following changes in packages:
ViewerTest package:
New DRAW command vcomputehlr has been added to display result of HLR algo for shape object in v3d view:

vcomputehlr ShapeName HlrName [ EyeX EyeY EyeZ LookX LookY LookZ ] ,

where ShapeName is the name of initial shape being processed by HLR algo; HlrName is the name of interactive object that will be created to display result of HLR algorithm in v3d view; { EyeX, EyeY, EyeZ }, { LookX, LookY, LookZ } is the position of projector and direction of projection.
If position and direction are not defined command takes a position and view direction of an active v3d view.
TagsNo tags attached.
Test case numberchl 934 B4
Attached Filesgz file icon HLRBRep_PolyAlgo.cxx.gz (18,932 bytes) 2008-08-13 14:27
7z file icon HLRBRep_PolyAlgo.7z (14,804 bytes) 2011-04-28 17:54
? file icon 7691test.tcl (1,340 bytes) 2011-09-06 13:37
? file icon bottle.brep (405,604 bytes) 2011-09-09 13:01
gz file icon chl_934_B4.tar.gz (742 bytes) 2011-09-09 13:59

- Relationships

-  Notes
(0017936)
bugmaster (administrator)
2011-08-09 12:39

Dear Anton,

Please prepare branch for bug , merge with files from
HLRBRep_PolyAlgo.7z and then make revision in order to tests this
fix for development version
(0017960)
apl (developer)
2011-08-11 14:38

Dear bugmaster,

SVN branch http://svn/svn/occt/branches/OCC7691 [^] has been created and reviewed.
The branch passed review without remarks and ready for test.
(0018042)
miv (tester)
2011-08-31 11:03
edited on: 2011-11-25 11:43

Dear Anton,

Please provide the test script for this bug.
--
Regards,
Mike

(0018051)
miv (tester)
2011-09-01 11:57
edited on: 2011-11-25 11:44

Dear BugMaster,

The wokbench KAS:dev:mkv-OCC7691-products was tested on linux platform.

Regressions cases were not found.

--
Regards,
Mike

(0018058)
apl (developer)
2011-09-01 15:54
edited on: 2011-11-25 11:44

Dear Mike,

It is necessary to write an additional test command for testing this issue, this command will be based on same code as in comments. Writing a test script will be possible only if command will produce bad result without this fix.

At the moment I begin to write this command, but of course, this will take an additional time, so I'll provide such a command/script soon.

Regards,
APV

(0018076)
apl (developer)
2011-09-06 13:41

Dear Mike,

You can use test script for this issues "7691test.tcl";

New DRAW command vcomputehlr has been added: file ViewerTest_ObjectCommands.cxx has been modified in SVN branch http://svn/svn/occt/branches/OCC7691 [^]
(0018100)
mkv (tester)
2011-09-09 13:32
edited on: 2011-11-25 11:45

Dear BugMaster,
Workbench KAS:dev:mkv-OCC7691-occt has been created from SVN branch http://svn/svn/occt/branches/OCC7691 [^]
(and mkv-OCC7691-products from trank) and compiled on Linux platform.

Test case for this bug is chl/934/B4 is OK in mkv-OCC7691-products.
There are not regressions in mkv-OCC7691-products regarding to KAS:dev:products-20110902-opt

See results in /QADisk/occttests/results/KAS/dev/mkv-OCC7691-products_08092011/lin
See reference results in /QADisk/occttests/results/KAS/dev/products-20110902-opt_05092011/lin
See test cases in /QADisk/occttests/tests/ED
N.B. In order to launch testing case you can make use the following instructions
http://doc/doku.php?id=occt:certification [^]

(0018101)
bugmaster (administrator)
2011-09-09 14:15

Date: 2011-09-09 14:14:53 +0400 (Fri, 09 Sep 2011)
New Revision: 8991

Modified:
   trunk/src/HLRBRep/HLRBRep_PolyAlgo.cxx
   trunk/src/ViewerTest/ViewerTest_ObjectCommands.cxx

- Related Changesets
occt: master 3fc57801
Timestamp: 2011-09-09 10:14:53
Author: bugmaster
Details ] Diff ]
0007691: Wrong hidden lines computed by HLRBRep_PolyAlgo and HLRBRep_PolyHLRToShape in OCC 5.1 Developed : IFV, VSV and APL
mod - src/HLRBRep/HLRBRep_PolyAlgo.cxx Diff ] File ]
mod - src/ViewerTest/ViewerTest_ObjectCommands.cxx Diff ] File ]

- Issue History
Date Modified Username Field Change
2005-01-11 14:38 bugmaster Channel => Internal
2005-01-12 16:13 bugmaster Status closed => assigned
2005-01-12 16:13 bugmaster Resolution suspended => @0@
2005-01-12 16:13 bugmaster Assigned To bugmaster => san
2008-08-13 16:48 bugmaster Assigned To san => ifv
2008-08-13 16:48 bugmaster Status assigned => resolved
2011-04-06 18:46 bugmaster Assigned To ifv => szy
2011-04-06 18:46 bugmaster Status resolved => assigned
2011-04-07 15:31 szy Assigned To szy => kgv
2011-04-07 18:10 bugmaster Assigned To kgv => apl
2011-04-21 14:39 bugmaster Assigned To apl => vsv
2011-04-28 17:53 vsv Status assigned => resolved
2011-08-02 11:24 bugmaster Category OCCT:VIZ => OCCT:Visualization
2011-08-09 12:39 bugmaster Note Added: 0017936
2011-08-09 12:39 bugmaster Assigned To vsv => apl
2011-08-09 12:39 bugmaster Status resolved => assigned
2011-08-11 14:38 apl Note Added: 0017960
2011-08-11 14:39 apl Status assigned => reviewed
2011-08-31 11:03 miv Note Added: 0018042
2011-09-01 11:57 miv Note Added: 0018051
2011-09-01 15:54 apl Note Added: 0018058
2011-09-06 13:37 apl Description Updated View Revisions
2011-09-06 13:37 apl Additional Information Updated View Revisions
2011-09-06 13:37 apl File Added: 7691test.tcl
2011-09-06 13:41 apl Note Added: 0018076
2011-09-09 13:01 apl File Added: bottle.brep
2011-09-09 13:32 mkv Note Added: 0018100
2011-09-09 13:32 mkv Status reviewed => tested
2011-09-09 13:59 mkv Test case number => chl 934 B4
2011-09-09 13:59 mkv File Added: chl_934_B4.tar.gz
2011-09-09 14:15 bugmaster Note Added: 0018101
2011-09-09 14:15 bugmaster Status tested => verified
2011-09-09 14:16 bugmaster Fixed in Version 6.3.0 =>
2011-09-09 14:16 bugmaster Target Version => 6.5.2
2011-11-25 11:43 szy Note Edited: 0018042 View Revisions
2011-11-25 11:44 szy Note Edited: 0018051 View Revisions
2011-11-25 11:44 szy Note Edited: 0018058 View Revisions
2011-11-25 11:44 szy Note Edited: 0018100 View Revisions
2011-11-25 11:45 szy Note Edited: 0018100 View Revisions
2012-03-29 17:26 bugmaster Changeset attached => occt master 3fc57801


Copyright © 2000 - 2018 MantisBT Team
Powered by Mantis Bugtracker